/** 
 * This program is free software: you can redistribute it and/or modify it under the terms of the
 * GNU Affero General Public License as published by the Free Software Foundation, either version 3
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
 * even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Affero General Public License for more details.
 * 
 * You should have received a copy of the GNU Affero General Public License along with this program.
 * If not, see http://www.gnu.org/licenses/.
*/
package com.owc.singularity.engine.object.model;


import com.owc.singularity.engine.metadata.ExampleSetMetaData;
import com.owc.singularity.engine.metadata.transformer.ExampleSetMetaDataTransformer;
import com.owc.singularity.engine.object.AbstractIOObject;
import com.owc.singularity.engine.object.Model;
import com.owc.singularity.engine.object.data.exampleset.ExampleSet;
import com.owc.singularity.engine.object.data.exampleset.ExampleSetHeader;
import com.owc.singularity.engine.object.data.exampleset.ExampleSetHeader.TrainingSetRelation;
import com.owc.singularity.engine.operator.error.UserError;


/**
 * Abstract model is the superclass for all objects which change a data set. For example, a model
 * generated by a learner might add a predicted attribute. Other models can be created during
 * preprocessing, e.g. a transformation model containing the parameters for a z-transformation.
 * Models can be combined by using a CompositionModel. All models can be applied with a ModelApply
 * operator.
 * 
 * @author Ingo Mierswa
 */
public abstract class AbstractModel extends AbstractIOObject implements Model {

    private static final long serialVersionUID = 1640348739650532634L;

    /**
     * This header example set contains all important nominal mappings of all training attributes.
     * These mappings are necessary in order to ensure that the internally used double values
     * encoding nominal values are equal for the training and application data sets.
     */
    private ExampleSetHeader exampleSetHeader;

    /**
     * This parameter specifies the allowed relation between the training {@link ExampleSet} and the
     * input {@link ExampleSet} on which this model is applied. Some models might support, that the
     * given set only contains a subset of attributes. Most models will probably only work on the
     * same header or on a super set of the training attributes.
     */
    private ExampleSetHeader.TrainingSetRelation allowedSetRelation;

    /**
     * This is a transformer that will change {@link ExampleSetMetaData} to simulate the application
     * of this model
     */
    private ExampleSetMetaDataTransformer applicationMetaDataTransformer;

    /**
     * Created a new model which was built on the given example set. Please note that the given
     * example set is automatically transformed into a {@link ExampleSetHeader} which means that no
     * reference to the data itself is kept but only to the header, i.e. to the attribute meta
     * descriptions.
     */
    protected AbstractModel(ExampleSetHeader header, TrainingSetRelation allowedSetRelation, ExampleSetMetaDataTransformer applicationMetaDataTransformer) {
        this.exampleSetHeader = header;
        this.allowedSetRelation = allowedSetRelation;
        this.applicationMetaDataTransformer = applicationMetaDataTransformer;
    }

    /**
     * Created a new model which was built on the given example set. Please note that the given
     * example set is automatically transformed into a {@link ExampleSetHeader} which means that no
     * reference to the data itself is kept but only to the header, i.e. to the attribute meta
     * descriptions.
     */
    protected AbstractModel(ExampleSet exampleSet, TrainingSetRelation allowedSetRelation, ExampleSetMetaDataTransformer applicationMetaDataTransformer) {
        this(exampleSet.getHeader(), allowedSetRelation, applicationMetaDataTransformer);
    }

    /**
     * Delivers the training header example set, i.e. the header of the example set (without data
     * reference) which was used for creating this model. Might return null.
     */
    @Override
    public ExampleSetHeader getTrainingHeader() {
        return this.exampleSetHeader;
    }

    /**
     * This method is invoked before the model is actually applied. The default implementation
     * performs some basic compatibility checks and writes warnings if the given example set (for
     * applying the model) does not fit the training example set. Subclasses might override this
     * method and might throw exceptions which will prevent the application of the model.
     * 
     */
    @Override
    public void checkCompatibility(ExampleSetHeader exampleSetHeader) throws UserError {
        // check given constraints (might throw an UserError)
        getTrainingHeader().checkMatching(exampleSetHeader, getAllowedSetRelation());
    }

    @Override
    public boolean isInTargetEncoding() {
        return false;
    }

    @Override
    public ExampleSetMetaDataTransformer getApplicationMetaDataTransformer() {
        return applicationMetaDataTransformer;
    }

    @Override
    public ExampleSetHeader.TrainingSetRelation getAllowedSetRelation() {
        return allowedSetRelation;
    }


}
